/*
-----------------------------------------------------
   Application Name: "DIMG"
Application Version: 0.1.0
          File Name: Dimg.h
       File Version: 0.0.1
         Start Date: 27/06/2008
          Author(s): David Goodwin
          Copyright: (C) Copyright David Goodwin, 2008
            License: GNU General Public License
   File Description: DIMG Class header
-----------------------------------------------------
	This file is part of "DIMG".

    This is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This software is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this software; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

	File Notes:
	------------------
*/


#ifndef DIMG_H
#define DIMG_H

// ------------------
// Headder files:
// ------------------
#include <QObject>
#include <QMainWindow>
#include <QApplication>
#include <QString>
#include <QStringList>
#include <QProgressDialog>
#include <QMessageBox>
#include <QFileDialog>
#include "ui_main_window.h"
#include "qlibdsk.h"
#include "constants.h"


/**
\brief The Dimg class manages the MainWindow UI

This class does nothing but automatically setup Ui::MainWindowUI with itself as the
parent.
*/
class Dimg : public QMainWindow
{
      Q_OBJECT

public:
	// Public Functions:
	Dimg(QApplication *app);	/*!< The Class Constructor */

	static QString versionString();
	static QStringList getFloppyDrives();

private slots:
	void getInfo();				/*!< Displays disk/image information */
	void formatDisk();			/*!< Formats a disk/image */
	void copyDisk();			/*!< Copies a disk */
	void browseFormatImage();	/*!< Displays an open dialog to select an image to format */
	void browseCopySrcImage();	/*!< Displays an open dialog to select a source image to copy */
	void browseCopyDestImage();	/*!< Displays an open dialog to select a target image to copy to */

private:
	// Private variables
	Ui::MainWindowUI ui; /*!< The main window ui object */
	QApplication *pApp;	 /*!< The application object */
};

#endif // DIMG_H
